/*----- PROTECTED REGION ID(PduMapperClass.h) ENABLED START -----*/
//=============================================================================
//
// file :        PduMapperClass.h
//
// description : Include for the PduMapper root class.
//               This class is the singleton class for
//                the PduMapper device class.
//               It contains all properties and methods which the 
//               PduMapper requires only once e.g. the commands.
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: alessandro.olivo $
//
// $Revision: 1.1.1.1 $
// $Date: 2017-10-02 14:01:30 $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef PduMapperClass_H
#define PduMapperClass_H

#include <tango.h>
#include <PduMapper.h>


/*----- PROTECTED REGION END -----*/	//	PduMapperClass.h


namespace PduMapper_ns
{
/*----- PROTECTED REGION ID(PduMapperClass::classes for dynamic creation) ENABLED START -----*/


/*----- PROTECTED REGION END -----*/	//	PduMapperClass::classes for dynamic creation

//=========================================
//	Define classes for commands
//=========================================
//	Command GetPduListFromNamePattern class definition
class GetPduListFromNamePatternClass : public Tango::Command
{
public:
	GetPduListFromNamePatternClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	GetPduListFromNamePatternClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~GetPduListFromNamePatternClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<PduMapper *>(dev))->is_GetPduListFromNamePattern_allowed(any);}
};

//	Command GetPduListFromOutletPattern class definition
class GetPduListFromOutletPatternClass : public Tango::Command
{
public:
	GetPduListFromOutletPatternClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	GetPduListFromOutletPatternClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~GetPduListFromOutletPatternClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<PduMapper *>(dev))->is_GetPduListFromOutletPattern_allowed(any);}
};

//	Command GetPduInfoFromName class definition
class GetPduInfoFromNameClass : public Tango::Command
{
public:
	GetPduInfoFromNameClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	GetPduInfoFromNameClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~GetPduInfoFromNameClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<PduMapper *>(dev))->is_GetPduInfoFromName_allowed(any);}
};

//	Command GetOutletsListFromOutletPattern class definition
class GetOutletsListFromOutletPatternClass : public Tango::Command
{
public:
	GetOutletsListFromOutletPatternClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	GetOutletsListFromOutletPatternClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~GetOutletsListFromOutletPatternClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<PduMapper *>(dev))->is_GetOutletsListFromOutletPattern_allowed(any);}
};


/**
 *	The PduMapperClass singleton definition
 */

#ifdef _TG_WINDOWS_
class __declspec(dllexport)  PduMapperClass : public Tango::DeviceClass
#else
class PduMapperClass : public Tango::DeviceClass
#endif
{
	/*----- PROTECTED REGION ID(PduMapperClass::Additionnal DServer data members) ENABLED START -----*/
	
	
	/*----- PROTECTED REGION END -----*/	//	PduMapperClass::Additionnal DServer data members

	public:
		//	write class properties data members
		Tango::DbData	cl_prop;
		Tango::DbData	cl_def_prop;
		Tango::DbData	dev_def_prop;
	
		//	Method prototypes
		static PduMapperClass *init(const char *);
		static PduMapperClass *instance();
		~PduMapperClass();
		Tango::DbDatum	get_class_property(string &);
		Tango::DbDatum	get_default_device_property(string &);
		Tango::DbDatum	get_default_class_property(string &);
	
	protected:
		PduMapperClass(string &);
		static PduMapperClass *_instance;
		void command_factory();
		void attribute_factory(vector<Tango::Attr *> &);
		void pipe_factory();
		void write_class_property();
		void set_default_property();
		void get_class_property();
		string get_cvstag();
		string get_cvsroot();
	
	private:
		void device_factory(const Tango::DevVarStringArray *);
		void create_static_attribute_list(vector<Tango::Attr *> &);
		void erase_dynamic_attributes(const Tango::DevVarStringArray *,vector<Tango::Attr *> &);
		vector<string>	defaultAttList;
		Tango::Attr *get_attr_object_by_name(vector<Tango::Attr *> &att_list, string attname);
};

}	//	End of namespace

#endif   //	PduMapper_H
