/*----- PROTECTED REGION ID(PduMapperStateMachine.cpp) ENABLED START -----*/
//=============================================================================
//
// file :        PduMapperStateMachine.cpp
//
// description : State machine file for the PduMapper class
//
// project :     
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author: alessandro.olivo $
//
// $Revision: 1.1.1.1 $
// $Date: 2017-10-02 14:01:30 $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================

#include <PduMapper.h>

/*----- PROTECTED REGION END -----*/	//	PduMapper::PduMapperStateMachine.cpp

//================================================================
//  States   |  Description
//================================================================
//  FAULT    |  None PDU device server is mapped
//  ON       |  All PDU device servers are mapped and are responsive
//  UNKNOWN  |  One (or more) PDU device server isn`t mapped


namespace PduMapper_ns
{
//=================================================
//		Attributes Allowed Methods
//=================================================


//=================================================
//		Commands Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method      : PduMapper::is_GetPduListFromNamePattern_allowed()
 *	Description : Execution allowed for GetPduListFromNamePattern attribute
 */
//--------------------------------------------------------
bool PduMapper::is_GetPduListFromNamePattern_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::FAULT ||
		get_state()==Tango::INIT)
	{
	/*----- PROTECTED REGION ID(PduMapper::GetPduListFromNamePatternStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	PduMapper::GetPduListFromNamePatternStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : PduMapper::is_GetPduListFromOutletPattern_allowed()
 *	Description : Execution allowed for GetPduListFromOutletPattern attribute
 */
//--------------------------------------------------------
bool PduMapper::is_GetPduListFromOutletPattern_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::FAULT ||
		get_state()==Tango::INIT)
	{
	/*----- PROTECTED REGION ID(PduMapper::GetPduListFromOutletPatternStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	PduMapper::GetPduListFromOutletPatternStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : PduMapper::is_GetPduInfoFromName_allowed()
 *	Description : Execution allowed for GetPduInfoFromName attribute
 */
//--------------------------------------------------------
bool PduMapper::is_GetPduInfoFromName_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::FAULT ||
		get_state()==Tango::INIT)
	{
	/*----- PROTECTED REGION ID(PduMapper::GetPduInfoFromNameStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	PduMapper::GetPduInfoFromNameStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : PduMapper::is_GetOutletsListFromOutletPattern_allowed()
 *	Description : Execution allowed for GetOutletsListFromOutletPattern attribute
 */
//--------------------------------------------------------
bool PduMapper::is_GetOutletsListFromOutletPattern_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for GetOutletsListFromOutletPattern command.
	/*----- PROTECTED REGION ID(PduMapper::GetOutletsListFromOutletPatternStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	PduMapper::GetOutletsListFromOutletPatternStateAllowed
	return true;
}


/*----- PROTECTED REGION ID(PduMapper::PduMapperStateAllowed.AdditionalMethods) ENABLED START -----*/

//	Additional Methods

/*----- PROTECTED REGION END -----*/	//	PduMapper::PduMapperStateAllowed.AdditionalMethods

}	//	End of namespace
